# $Revision: 1.251 $, $Date: 2008-02-06 21:21:20 $
# TODO
# - mod_caps uses uname -r for detection
# - don't use internal libltdl
#
# Conditional build:
%bcond_without	pam		# disable PAM support
%bcond_without	ipv6		# disable IPv6 and TCPD support
%bcond_without	ssl		# disbale TLS/SSL support
%bcond_without	ldap		# disable LDAP support
%bcond_without	mysql		# disable MySQL support
%bcond_without	pgsql		# disable PostgreSQL support
%bcond_without	quotafile	# disable quota file support
%bcond_without	quotaldap	# disable quota ldap support
%bcond_without	quotamysql	# disable quota mysql support
%bcond_without	quotapgsql	# disable quota pgsql support
#
Summary:	PROfessional FTP Daemon with apache-like configuration syntax
Summary(es.UTF-8):	Servidor FTP profesional, con sintaxis de configuración semejante a la del apache
Summary(pl.UTF-8):	PROfesionalny serwer FTP
Summary(pt_BR.UTF-8):	Servidor FTP profissional, com sintaxe de configuração semelhante à do apache
Summary(zh_CN.UTF-8):	易于管理的,安全的 FTP 服务器
Name:		proftpd
Version:	1.3.1
Release:	4
Epoch:		2
License:	GPL v2+
Group:		Daemons
Source0:	ftp://ftp.proftpd.org/distrib/source/%{name}-%{version}.tar.bz2
# Source0-md5:	175958df8de92d5209b7b1e2e23a5a28
Source1:	%{name}.conf
Source3:	ftp.pamd
Source4:	%{name}.inetd
Source5:	%{name}.sysconfig
Source6:	%{name}.init
Source7:	ftpusers.tar.bz2
# Source7-md5:	76c80b6ec9f4d079a1e27316edddbe16
Source9:	%{name}-mod_pam.conf
Source10:	%{name}-mod_tls.conf
Source11:	%{name}-anonftp.conf
Patch0:		%{name}-umode_t.patch
Patch1:		%{name}-paths.patch
Patch2:		%{name}-noautopriv.patch
Patch3:		%{name}-wtmp.patch
Patch4:		%{name}-configure.patch
Patch5:		%{name}-pool.patch
URL:		http://www.proftpd.org/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	libstdc++-devel
BuildRequires:	libwrap-devel
%if %{with mysql} || %{with quotamysql}
BuildRequires:	mysql-devel
%endif
BuildRequires:	ncurses-devel
%if %{with ldap} || %{with quotaldap}
BuildRequires:	openldap-devel
%endif
%{?with_ssl:BuildRequires:	openssl-devel >= 0.9.7d}
%{?with_pam:BuildRequires:		pam-devel}
%if %{with pgsql} || %{with quotapgsql}
BuildRequires:	postgresql-devel
%endif
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sysconfdir		/etc/ftpd
%define		_localstatedir	/var/run
%define		_libexecdir		%{_prefix}/%{_lib}/%{name}

%description
ProFTPD is a highly configurable FTP daemon for unix and unix-like
operating systems. ProFTPD is designed to be somewhat of a "drop-in"
replacement for wu-ftpd. Full online documentation is available at
<http://www.proftpd.org/>, including a server configuration directive
reference manual.

%description -l es.UTF-8
ProFTPD es un servidor FTP altamente configurable para sistemas
operativos unix. Está proyectado para ser un substituto directo al
wu-ftpd. La documentación completa está disponible en
<http://www.proftpd.org/>, incluido el manual de referencia para las
directivas de configuración del servidor.

%description -l pl.UTF-8
ProFTPD jest wysoce konfigurowalnym serwerem FTP dla systemów Unix.
ProFTPD jest robiony jako bezpośredni zamiennik wu-ftpd. Pełna
dokumentacja jest dostępna on-line pod <http://www.proftpd.org/>
włącznie z dokumentacją dotyczącą konfigurowania.

%description -l pt_BR.UTF-8
O ProFTPD é um servidor FTP altamente configurável para sistemas
operacionais unix.

É projetado para ser um substituto direto para o wu-ftpd. A
documentação completa está disponível em <http://www.proftpd.org/>,
incluindo o manual de referência para as diretivas de configuração do
servidor.

%package common
Summary:	PROfessional FTP Daemon with apache-like configuration syntax - common files
Summary(pl.UTF-8):	PROfesionalny serwer FTP  - wspólne pliki
Group:		Daemons
Requires(post):	awk
Requires(post):	fileutils
Obsoletes:	proftpd < 0:1.2.2rc1-3

%description common
ProFTPD is a highly configurable FTP daemon for unix and unix-like
operating systems. ProFTPD is designed to be somewhat of a "drop-in"
replacement for wu-ftpd. Full online documentation is available at
<http://www.proftpd.org/>, including a server configuration directive
reference manual.

%description common -l es.UTF-8
ProFTPD es un servidor FTP altamente configurable para sistemas
operativos unix. Está proyectado para ser un substituto directo al
wu-ftpd. La documentación completa está disponible en
<http://www.proftpd.org/>, incluido el manual de referencia para las
directivas de configuración del servidor.

%description common -l pl.UTF-8
ProFTPD jest wysoce konfigurowalnym serwerem FTP dla systemów Unix.
ProFTPD jest robiony jako bezpośredni zamiennik wu-ftpd. Pełna
dokumentacja jest dostępna on-line pod <http://www.proftpd.org/>
włącznie z dokumentacją dotyczącą konfigurowania.

%description common -l pt_BR.UTF-8
O ProFTPD é um servidor FTP altamente configurável para sistemas
operacionais unix.

É projetado para ser um substituto direto para o wu-ftpd. A
documentação completa está disponível em <http://www.proftpd.org/>,
incluindo o manual de referência para as diretivas de configuração do
servidor.

%package inetd
Summary:	inetd configs for proftpd
Summary(pl.UTF-8):	Pliki konfiguracyjne do użycia proftpd poprzez inetd
Group:		Daemons
Requires(post):	fileutils
Requires(post):	grep
Requires(post):	sed >= 4.0
Requires(triggerpostun):	sed >= 4.0
Requires:	%{name}-common = %{epoch}:%{version}-%{release}
Requires:	rc-inetd
Provides:	ftpserver
Provides:	proftpd = %{epoch}:%{version}-%{release}
Obsoletes:	anonftp
Obsoletes:	bftpd
Obsoletes:	ftpd-BSD
Obsoletes:	ftpserver
Obsoletes:	glftpd
Obsoletes:	heimdal-ftpd
Obsoletes:	krb5-ftpd
Obsoletes:	linux-ftpd
Obsoletes:	muddleftpd
Obsoletes:	proftpd-standalone
Obsoletes:	pure-ftpd
Obsoletes:	troll-ftpd
Obsoletes:	vsftpd
Obsoletes:	wu-ftpd
Conflicts:	man-pages < 1.51
Conflicts:	rpm < 4.4.2-0.2

%description inetd
ProFTPD configs for running from inetd.

%description inetd -l pl.UTF-8
Pliki konfiguracyjna ProFTPD do startowania demona poprzez inetd.

%package standalone
Summary:	Standalone daemon configs for proftpd
Summary(pl.UTF-8):	Pliki konfiguracyjne do startowania proftpd w trybie standalone
Group:		Daemons
Requires(post):	fileutils
Requires(post):	grep
Requires(post):	sed >= 4.0
Requires(post,preun):	/sbin/chkconfig
Requires(triggerpostun):	sed >= 4.0
Requires:	%{name}-common = %{epoch}:%{version}-%{release}
Requires:	rc-scripts
Provides:	ftpserver
Provides:	proftpd = %{epoch}:%{version}-%{release}
Obsoletes:	anonftp
Obsoletes:	bftpd
Obsoletes:	ftpd-BSD
Obsoletes:	ftpserver
Obsoletes:	glftpd
Obsoletes:	heimdal-ftpd
Obsoletes:	krb5-ftpd
Obsoletes:	linux-ftpd
Obsoletes:	muddleftpd
Obsoletes:	proftpd-inetd
Obsoletes:	pure-ftpd
Obsoletes:	troll-ftpd
Obsoletes:	vsftpd
Obsoletes:	wu-ftpd
Conflicts:	man-pages < 1.51
Conflicts:	rpm < 4.4.2-0.2

%description standalone
ProFTPD configs for running as a standalone daemon.

%description standalone -l pl.UTF-8
Pliki konfiguracyjne ProFTPD do startowania demona w trybie
standalone.

%package devel
Summary:	Header files ProFTPD
Summary(pl.UTF-8):	Pliki nagłówkowe ProFTPD
Group:		Development/Libraries
Requires:	acl-devel

%description devel
This is the package containing the header files for ProFTPD.

%description devel -l pl.UTF-8
Ten pakiet zawiera pliki nagłówkowe ProFTPD

%package anonftp
Summary:	Anonymous FTP config for ProFTPD
Summary(pl.UTF-8):	Konfiguracja anonimowego FTP dla ProFTPD
Group:		Daemons
Requires:	%{name}-common = %{epoch}:%{version}-%{release}

%description anonftp
Anonymous FTP config for ProFTPD.

%description anonftp -l pl.UTF-8
Konfiguracja anonimowego FTP dla ProFTPD.

%package mod_auth_pam
Summary:	ProFTPD PAM auth module
Summary(pl.UTF-8):	Moduł uwierzytelnienia PAM dla ProFTPD
Group:		Daemons
Requires:	%{name}-common = %{epoch}:%{version}-%{release}
Requires:	pam >= 0.79.0

%description mod_auth_pam
PAM authentication method for ProFTPD.

%description mod_auth_pam -l pl.UTF-8
Metoda uwierzytelnienia PAM dla ProFTPD.

%package mod_ldap
Summary:	ProFTPD OpenLDAP module
Summary(pl.UTF-8):	Moduł OpenLDAP dla ProFTPD
Group:		Daemons
Requires:	%{name}-common = %{epoch}:%{version}-%{release}

%description mod_ldap
mod_ldap provides LDAP authentication support for ProFTPD. It supports
many features useful in "toaster" environments such as default UID/GID
and autocreation/autogeneration of home directories.

%description mod_ldap -l pl.UTF-8
mod_ldap dodaje obsługę uwierzytelnienia LDAP do ProFTPD. Obsługuje
wiele cech przydatnych w środowiskach "tosterowych", takich jak
domyślny UID/GID i automatyczne tworzenie/generowanie katalogów
domowych.

%package mod_quotatab
Summary:	ProFTPD quotatab module
Summary(pl.UTF-8):	Moduł quotatab dla ProFTPD
Group:		Daemons
Requires:	%{name}-common = %{epoch}:%{version}-%{release}

%description mod_quotatab
A module for managing FTP byte/file quotas via centralized tables.

%description mod_quotatab -l pl.UTF-8
Moduł do zarządzania ograniczeniami bajtów/plików FTP poprzez
scentralizowane tabele.

%package mod_quotatab_file
Summary:	ProFTPD quotatab file module
Summary(pl.UTF-8):	Moduł quotatab_file dla ProFTPD
Group:		Daemons
Requires:	%{name}-common = %{epoch}:%{version}-%{release}
Requires:	%{name}-mod_quotatab = %{epoch}:%{version}-%{release}

%description mod_quotatab_file
A mod_quotatab sub-module for managing quota data via file-based
tables.

%description mod_quotatab_file -l pl.UTF-8
Podmoduł mod_quotatab do zarządzania danymi o ograniczeniach poprzez
tabele zapisane w pliku.

%package mod_quotatab_ldap
Summary:	ProFTPD quotatab ldap module
Summary(pl.UTF-8):	Moduł quotatab_ldap dla ProFTPD
Group:		Daemons
Requires:	%{name}-common = %{epoch}:%{version}-%{release}
Requires:	%{name}-mod_ldap = %{epoch}:%{version}-%{release}
Requires:	%{name}-mod_quotatab = %{epoch}:%{version}-%{release}

%description mod_quotatab_ldap
A mod_quotatab sub-module for obtaining quota information from an LDAP
directory.

%description mod_quotatab_ldap -l pl.UTF-8
Podmoduł mod_quotatab do pobierania informacji o ograniczeniach z
katalogu LDAP.

%package mod_quotatab_sql
Summary:	ProFTPD quotatab sql module
Summary(pl.UTF-8):	Moduł quotatab_sql dla ProFTPD
Group:		Daemons
Requires:	%{name}-common = %{epoch}:%{version}-%{release}
Requires:	%{name}-mod_quotatab = %{epoch}:%{version}-%{release}
Requires:	%{name}-mod_sql = %{epoch}:%{version}-%{release}

%description mod_quotatab_sql
A mod_quotatab sub-module for managing quota data via SQL-based
tables.

%description mod_quotatab_sql -l pl.UTF-8
Podmoduł mod_quotatab do zarządzania danymi o ograniczeniach poprzez
tabele SQL.

%package mod_ratio
Summary:	ProFTPD ratio module
Summary(pl.UTF-8):	Moduł ratio dla ProFTPD
Group:		Daemons
Requires:	%{name}-common = %{epoch}:%{version}-%{release}

%description mod_ratio
Support upload/download ratios.

%description mod_ratio -l pl.UTF-8
Obsługa współczynników upload/download.

%package mod_readme
Summary:	ProFTPD readme module
Summary(pl.UTF-8):	Moduł readme dla ProFTPD
Group:		Daemons
Requires:	%{name}-common = %{epoch}:%{version}-%{release}

%description mod_readme
"README" file support.

%description mod_readme -l pl.UTF-8
Obsługa pliku "README".

%package mod_sql
Summary:	ProFTPD SQL support module
Summary(pl.UTF-8):	Moduł obsługi SQL dla ProFTPD
Group:		Daemons
Requires:	%{name}-common = %{epoch}:%{version}-%{release}

%description mod_sql
This module provides the necessary support for SQL based
authentication, logging and other features as required.

%description mod_sql -l pl.UTF-8
Ten moduł dodaje obsługę SQL potrzebną do uwierzytelniania, logowania
i innych możliwości opartych o SQL.

%package mod_sql_mysql
Summary:	ProFTPD sql mysql module
Summary(pl.UTF-8):	Moduł sql_mysql dla ProFTPD
Group:		Daemons
Requires:	%{name}-common = %{epoch}:%{version}-%{release}
Requires:	%{name}-mod_sql = %{epoch}:%{version}-%{release}

%description mod_sql_mysql
Support for connecting to MySQL databases.

%description mod_sql_mysql -l pl.UTF-8
Obsługa łączenia się z bazami danych MySQL.

%package mod_sql_postgres
Summary:	ProFTPD sql postgres module
Summary(pl.UTF-8):	Moduł sql_postgres dla ProFTPD
Group:		Daemons
Requires:	%{name}-common = %{epoch}:%{version}-%{release}
Requires:	%{name}-mod_sql = %{epoch}:%{version}-%{release}

%description mod_sql_postgres
Support for connecting to PostgreSQL databases.

%description mod_sql_postgres -l pl.UTF-8
Obsługa łączenia się z bazami danych PostgreSQL.

%package mod_tls
Summary:	ProFTPD TLS support
Summary(pl.UTF-8):	Obsługa TLS dla ProFTPD
Group:		Daemons
Requires:	%{name}-common = %{epoch}:%{version}-%{release}

%description mod_tls
An RFC2228 SSL/TLS module for ProFTPD.

%description mod_tls -l pl.UTF-8
Moduł SSL/TLS zgodny z RFC2228 dla ProFTPD.

%package mod_wrap
Summary:	ProFTPD interface to libwrap
Summary(pl.UTF-8):	Interfejs ProFTPD do libwrap
Group:		Daemons
Requires:	%{name}-common = %{epoch}:%{version}-%{release}
Requires:	libwrap

%description mod_wrap
It enables the daemon to use the common tcpwrappers access control
library while in standalone mode, and in a very configurable manner.

Many programs will automatically add entries in the common allow/deny
files, and use of this module will allow a ProFTPD daemon running in
standalone mode to adapt as these entries are added. The portsentry
program does this, for example: when illegal access is attempted, it
will add hosts to the /etc/hosts.deny file.

%description mod_wrap -l pl.UTF-8
Ten pakiet pozwala demonowi używać wspólnej biblioteki kontroli
dostępu tcpwrappers w trybie samodzielnym w bardzo wygodny sposób.

Wiele programów automatycznie dodaje wpisy we wspólnych plikach
allow/deny, a użycie tego modułu pozwala demonowi ProFTPD działającemu
w trybie samodzielnym adaptować te wpisy w miarę dodawania. Robi tak
na przykład program portsentry: przy próbie niedozwolonego dostępu
dodaje hosty do pliku /etc/hosts.deny.

%prep
%setup -q -n %{name}-%{version}%{?_rc}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

cp -f /usr/share/automake/config.sub .

# cleanup backups after patching
find . '(' -name '*~' -o -name '*.orig' ')' -print0 | xargs -0 -r -l512 rm -f

%build
%{__autoconf}

MODULES="
mod_ratio
mod_readme
mod_wrap
%{?with_ssl:mod_tls}
%{?with_pam:mod_auth_pam}
%{?with_ldap:mod_ldap}
%{?with_quotafile:mod_quotatab mod_quotatab_file}
%{?with_quotaldap:mod_quotatab mod_quotatab_ldap}
%{?with_quotamysql:mod_quotatab mod_quotatab_sql}
%{?with_quotapgsql:mod_quotatab mod_quotatab_sql}
%{?with_linuxprivs:mod_linuxprivs}
%{?with_mysql:mod_sql mod_sql_mysql}
%{?with_pgsql:mod_sql mod_sql_postgres}
"

MODARG=$(echo $MODULES | tr ' ' '\n' | sort -u | xargs | tr ' ' ':')
%configure \
	--with-includes=/usr/include/ncurses%{?with_mysql::%{_includedir}/mysql} \
	--enable-autoshadow \
	--enable-ctrls \
	--enable-dso \
	--enable-facl \
	%{?with_ipv6:--enable-ipv6} \
	--enable-sendfile \
	%{!?with_ssl:--disable-tls} \
	--with-shared=$MODARG \

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/etc/{pam.d,security,sysconfig/rc-inetd,rc.d/init.d} \
	$RPM_BUILD_ROOT/var/{lib/ftp/pub/Incoming,log} \
	$RPM_BUILD_ROOT%{_sysconfdir}/conf.d \
	$RPM_BUILD_ROOT%{_includedir}/%{name}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	INSTALL_USER=%(id -u) \
	INSTALL_GROUP=%(id -g)

rm $RPM_BUILD_ROOT%{_sbindir}/in.proftpd

install %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}
install %{SOURCE9} $RPM_BUILD_ROOT%{_sysconfdir}/conf.d/mod_auth_pam.conf
%{?with_ldap:echo 'LoadModule        mod_ldap.c' > $RPM_BUILD_ROOT%{_sysconfdir}/conf.d/mod_ldap.conf}
echo 'LoadModule        mod_quotatab.c' > $RPM_BUILD_ROOT%{_sysconfdir}/conf.d/mod_quotatab.conf
echo 'LoadModule        mod_quotatab_file.c' > $RPM_BUILD_ROOT%{_sysconfdir}/conf.d/mod_quotatab_file.conf
%{?with_quotaldap:echo 'LoadModule        mod_quotatab_ldap.c' > $RPM_BUILD_ROOT%{_sysconfdir}/conf.d/mod_quotatab_ldap.conf}
echo 'LoadModule        mod_ratio.c' > $RPM_BUILD_ROOT%{_sysconfdir}/conf.d/mod_ratio.conf
echo 'LoadModule        mod_readme.c' > $RPM_BUILD_ROOT%{_sysconfdir}/conf.d/mod_readme.conf
%if %{with mysql} || %{with pgsql}
echo 'LoadModule        mod_quotatab_sql.c' > $RPM_BUILD_ROOT%{_sysconfdir}/conf.d/mod_quotatab_sql.conf
echo 'LoadModule        mod_sql.c' > $RPM_BUILD_ROOT%{_sysconfdir}/conf.d/mod_sql.conf
%endif
%{?with_mysql:echo 'LoadModule        mod_sql_mysql.c' > $RPM_BUILD_ROOT%{_sysconfdir}/conf.d/mod_sql_mysql.conf}
%{?with_pgsql:echo 'LoadModule        mod_sql_postgres.c' > $RPM_BUILD_ROOT%{_sysconfdir}/conf.d/mod_sql_postgres.conf}
install %{SOURCE10} $RPM_BUILD_ROOT%{_sysconfdir}/conf.d/mod_tls.conf
echo 'LoadModule        mod_wrap.c' > $RPM_BUILD_ROOT%{_sysconfdir}/conf.d/mod_wrap.conf
install %{SOURCE11} $RPM_BUILD_ROOT%{_sysconfdir}/conf.d/anonftp.conf

%{?with_pam:install %{SOURCE3} $RPM_BUILD_ROOT/etc/pam.d/ftp}
install %{SOURCE4} $RPM_BUILD_ROOT/etc/sysconfig/rc-inetd/ftpd
install %{SOURCE5} $RPM_BUILD_ROOT/etc/sysconfig/proftpd
install %{SOURCE6} $RPM_BUILD_ROOT/etc/rc.d/init.d/proftpd
install contrib/xferstats.holger-preiss $RPM_BUILD_ROOT%{_bindir}/xferstat

bzip2 -dc %{SOURCE7} | tar xf - -C $RPM_BUILD_ROOT%{_mandir}

:> $RPM_BUILD_ROOT%{_sysconfdir}/ftpusers.default
:> $RPM_BUILD_ROOT%{_sysconfdir}/ftpusers

# only for -inetd package?
ln -sf proftpd $RPM_BUILD_ROOT%{_sbindir}/ftpd

:> $RPM_BUILD_ROOT/etc/security/blacklist.ftp

rm $RPM_BUILD_ROOT%{_libdir}/%{name}/*.a
rm $RPM_BUILD_ROOT%{_libdir}/%{name}/*.la

rm -f $RPM_BUILD_ROOT%{_mandir}/ftpusers-path.diff*
cp -aL include/* config.h $RPM_BUILD_ROOT%{_includedir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post common
umask 027
awk -F: '{ if (($3 < 500) && ($1 != "ftp")) print $1; }' < /etc/passwd >> %{_sysconfdir}/ftpusers.default
if [ ! -f %{_sysconfdir}/ftpusers ]; then
	cp -f %{_sysconfdir}/ftpusers.default %{_sysconfdir}/ftpusers
fi

%posttrans inetd
if grep -iEqs "^ServerType[[:space:]]+standalone" %{_sysconfdir}/proftpd.conf ; then
	cp -f %{_sysconfdir}/proftpd.conf{,.rpmorig}
	sed -i -e 's/^ServerType[[:space:]]\+standalone/ServerType			inetd/g' %{_sysconfdir}/proftpd.conf
fi
%service -q rc-inetd reload

%postun inetd
if [ "$1" = "0" ]; then
	%service -q rc-inetd reload
fi

%posttrans standalone
if grep -iEqs "^ServerType[[:space:]]+inetd" %{_sysconfdir}/proftpd.conf ; then
	cp -f %{_sysconfdir}/proftpd.conf{,.rpmorig}
	sed -i -e 's/^ServerType[[:space:]]\+inetd/ServerType			standalone/g' %{_sysconfdir}/proftpd.conf
fi
/sbin/chkconfig --add proftpd
%service proftpd restart "ProFTPD daemon"

%preun standalone
if [ "$1" = "0" ]; then
	%service proftpd stop
	/sbin/chkconfig --del proftpd
fi

# macro called at module post scriptlet
%define	module_post \
if [ "$1" = "1" ]; then \
	if grep -iEqs "^ServerType[[:space:]]+inetd" %{_sysconfdir}/proftpd.conf; then \
		%service -q rc-inetd reload \
	elif grep -iEqs "^ServerType[[:space:]]+standalone" %{_sysconfdir}/proftpd.conf; then \
		%service -q proftpd restart \
	fi \
fi

# macro called at module postun scriptlet
%define	module_postun \
if [ "$1" = "0" ]; then \
	if grep -iEqs "^ServerType[[:space:]]+inetd" %{_sysconfdir}/proftpd.conf; then \
		%service -q rc-inetd reload \
	elif grep -iEqs "^ServerType[[:space:]]+standalone" %{_sysconfdir}/proftpd.conf; then \
		%service -q proftpd restart \
	fi \
fi

# it's sooo annoying to write them
%define	module_scripts() \
%post %1 \
%module_post \
\
%postun %1 \
%module_postun

%module_scripts mod_auth_pam
%module_scripts mod_ldap
%module_scripts mod_quotatab
%module_scripts mod_quotatab_file
%module_scripts mod_quotatab_ldap
%module_scripts mod_quotatab_sql
%module_scripts mod_ratio
%module_scripts mod_readme
%module_scripts mod_sql
%module_scripts mod_sql_mysql
%module_scripts mod_sql_postgres
%module_scripts mod_tls
%module_scripts mod_wrap

%files common
%defattr(644,root,root,755)
%doc sample-configurations/*.conf CREDITS ChangeLog NEWS RELEASE_NOTES
%doc README README.capabilities README.classes README.controls README.IPv6
%doc README.modules
%doc doc/*html
%dir %attr(750,root,ftp) %dir %{_sysconfdir}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/*.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %ghost %{_sysconfdir}/ftpusers
%attr(640,root,root) %{_sysconfdir}/ftpusers.default
%dir %attr(750,root,root) %{_sysconfdir}/conf.d
#%attr(640,root,root) %ghost /var/log/*
%attr(755,root,root) %{_bindir}/*
%attr(755,root,root) %{_sbindir}/*
%dir %{_libdir}/%{name}
%dir /var/run/proftpd
%{_mandir}/man[18]/*
%dir /var/lib/ftp
%dir /var/lib/ftp/pub
%attr(711,ftp,ftp) %dir /var/lib/ftp/pub/Incoming

%files inetd
%defattr(644,root,root,755)
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/rc-inetd/ftpd
%{_mandir}/man5/*
%lang(ja) %{_mandir}/ja/man5/ftpusers*
%lang(pl) %{_mandir}/pl/man5/ftpusers*
%lang(pt_BR) %{_mandir}/pt_BR/man5/ftpusers*
%lang(ru) %{_mandir}/ru/man5/ftpusers*

%files standalone
%defattr(644,root,root,755)
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/proftpd
%attr(754,root,root) /etc/rc.d/init.d/proftpd
%{_mandir}/man5/*
%lang(ja) %{_mandir}/ja/man5/ftpusers*
%lang(pl) %{_mandir}/pl/man5/ftpusers*
%lang(pt_BR) %{_mandir}/pt_BR/man5/ftpusers*
%lang(ru) %{_mandir}/ru/man5/ftpusers*

%files devel
%defattr(644,root,root,755)
%{_includedir}/%{name}

%files anonftp
%defattr(644,root,root,755)
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/conf.d/anonftp.conf

%if %{with pam}
%files mod_auth_pam
%defattr(644,root,root,755)
%doc README.PAM
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/pam.d/*
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/security/blacklist.ftp
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/conf.d/mod_auth_pam.conf
%attr(755,root,root) %{_libexecdir}/mod_auth_pam.so
%endif

%if %{with ldap}
%files mod_ldap
%defattr(644,root,root,755)
%doc README.LDAP
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/conf.d/mod_ldap.conf
%attr(755,root,root) %{_libexecdir}/mod_ldap.so
%endif

%files mod_quotatab
%defattr(644,root,root,755)
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/conf.d/mod_quotatab.conf
%attr(755,root,root) %{_libexecdir}/mod_quotatab.so

%if %{with quotafile}
%files mod_quotatab_file
%defattr(644,root,root,755)
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/conf.d/mod_quotatab_file.conf
%attr(755,root,root) %{_libexecdir}/mod_quotatab_file.so
%endif

%if %{with quotaldap}
%files mod_quotatab_ldap
%defattr(644,root,root,755)
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/conf.d/mod_quotatab_ldap.conf
%attr(755,root,root) %{_libexecdir}/mod_quotatab_ldap.so
%endif

%if %{with quotamysql} || %{with quotapgsql}
%files mod_quotatab_sql
%defattr(644,root,root,755)
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/conf.d/mod_quotatab_sql.conf
%attr(755,root,root) %{_libexecdir}/mod_quotatab_sql.so
%endif

%files mod_ratio
%defattr(644,root,root,755)
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/conf.d/mod_ratio.conf
%attr(755,root,root) %{_libexecdir}/mod_ratio.so

%files mod_readme
%defattr(644,root,root,755)
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/conf.d/mod_readme.conf
%attr(755,root,root) %{_libexecdir}/mod_readme.so

%if %{with mysql} || %{with pgsql}
%files mod_sql
%defattr(644,root,root,755)
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/conf.d/mod_sql.conf
%attr(755,root,root) %{_libexecdir}/mod_sql.so
%endif

%if %{with mysql}
%files mod_sql_mysql
%defattr(644,root,root,755)
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/conf.d/mod_sql_mysql.conf
%attr(755,root,root) %{_libexecdir}/mod_sql_mysql.so
%endif

%if %{with pgsql}
%files mod_sql_postgres
%defattr(644,root,root,755)
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/conf.d/mod_sql_postgres.conf
%attr(755,root,root) %{_libexecdir}/mod_sql_postgres.so
%endif

%files mod_tls
%defattr(644,root,root,755)
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/conf.d/mod_tls.conf
%attr(755,root,root) %{_libexecdir}/mod_tls.so

%files mod_wrap
%defattr(644,root,root,755)
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/conf.d/mod_wrap.conf
%attr(755,root,root) %{_libexecdir}/mod_wrap.so

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: proftpd.spec,v $
Revision 1.251  2008-02-06 21:21:20  glen
- rel 4

Revision 1.250  2008-02-06 21:02:00  glen
- never use '<=' in trigger comparision (drop old triggers); rel 3

Revision 1.249  2008-02-04 08:19:28  glen
- -devel R acl-devel: /usr/include/proftpd/conf.h:79:22: error: sys/acl.h: No such file or directory

Revision 1.248  2008-01-08 20:50:02  glen
- update to 1.3.1

Revision 1.247  2007-11-18 17:59:34  arekm
- rel .2

Revision 1.246  2007-11-03 02:10:03  baggins
- updated openldap BR/R to 2.4.6

Revision 1.245  2007/09/05 13:24:32  shadzik
- BR: libstdc++-devel
- cosmetics

Revision 1.244  2007/08/20 14:10:13  baggins
- fix release

Revision 1.243  2007/08/20 14:06:34  baggins
- revert source url

Revision 1.242  2007/08/20 14:05:33  baggins
- get the source from dropin, ftp.proftpd.org has b0rken passive connections

Revision 1.241  2007/08/20 13:56:46  baggins
- updated to 1.3.1rc3
- fixed version numbering, epoch 2
- rewritten wtmp patch so it won't read entire wtmpx file

Revision 1.240  2007/06/04 20:00:25  qrczak
- Fixed bcond comment

Revision 1.239  2007/04/10 12:22:53  pascalek
- there are no files in /var/log

Revision 1.238  2007/03/31 22:02:59  baggins
- added krb5-ftpd to obsoletes

Revision 1.237  2007/03/22 17:22:41  baggins
- fix unnecessary merge

Revision 1.236  2007/03/22 17:20:37  baggins
- up to 1.3.1rc2

Revision 1.235  2007/02/13 08:06:42  glen
- tabs in preamble

Revision 1.234  2007/02/12 00:49:09  baggins
- converted to UTF-8

Revision 1.233  2006/12/20 09:31:21  qboosh
- added CVE reference for CORE-2006-1127

Revision 1.232  2006/12/15 08:39:28  qboosh
- added CVE-2006-6170 patch (from Debian)

Revision 1.231  2006/12/14 16:12:21  baggins
- fix CORE-2006-1127, ProFTPD Controls Buffer Overflow [CVE-2006-6563]

Revision 1.230  2006/12/14 16:01:12  baggins
- rel 4
- removed obsolete patches

Revision 1.229  2006/12/01 10:23:23  qboosh
- added CVE-2006-5815 patch

Revision 1.228  2006/10/24 10:58:59  qboosh
- added pool patch (fixes SEGV on start on some archs); release 3

Revision 1.227  2006/08/30 04:36:03  havner
- xferlog moved to syslog-ng
- rel 2

Revision 1.226  2006/06/07 11:32:29  zbyniu
- proper bconds support

Revision 1.225  2006/06/03 21:58:19  glen
- rel 1

Revision 1.224  2006/05/30 19:24:59  glen
- cleanup backups after patching
- dereference symlinks when copying includes

Revision 1.223  2006/05/17 14:49:02  qboosh
- pl for -anonftp

Revision 1.222  2006/05/17 12:41:53  glen
- separated anonftp config into subpackage

Revision 1.221  2006/05/11 21:45:54  qboosh
- pl for new subpackages

Revision 1.220  2006/04/30 11:43:04  glen
- fix ftptop linking with ncurses
- typo in anonftp.conf

Revision 1.219  2006/04/29 21:56:16  glen
- /etc/security/blacklist.ftp goes with pam

Revision 1.218  2006/04/29 21:55:37  glen
- anoftp config in separate file

Revision 1.217  2006/04/29 15:02:14  glen
- add mod_tls config

Revision 1.216  2006/04/29 14:18:01  glen
- copied 1.3.0 from DEVEL

Revision 1.211.2.16  2006/04/29 14:14:54  glen
- almost ready

Revision 1.211.2.15  2006/04/29 14:00:39  glen
- mod_shaper in separate spec
- created -devel for modules building

Revision 1.211.2.14  2006/04/29 13:06:31  glen
- add missing module descriptions
- update module inner deps

Revision 1.211.2.13  2006/04/29 12:54:22  glen
- separate modules into subpackages

Revision 1.211.2.12  2006/04/29 11:44:19  glen
- define _libexecdir for dir of dso modules

Revision 1.211.2.11  2006/04/29 11:34:46  glen
- cleanups, typos

Revision 1.211.2.10  2006/04/29 11:25:39  glen
- reviewed patches, clean duplicate BR

Revision 1.211.2.9  2006/04/29 11:04:48  glen
- merge %service and epoch fixes from HEAD

Revision 1.211.2.8  2006/04/29 11:03:11  glen
- cleanups, always enable DSO

Revision 1.211.2.7  2006/04/29 11:00:44  glen
- restore description for src.rpm
- kill duplicate description common -l pl

Revision 1.211.2.6  2006/04/29 10:59:36  glen
- adapter

Revision 1.211.2.5  2006/04/29 10:56:23  glen
- enable all modules as dso is possible now

Revision 1.211.2.4  2006/04/29 10:33:33  glen
- builds. not tested

Revision 1.211.2.3  2006/04/29 09:35:46  glen
- 1.3.0 tarball

Revision 1.211.2.2  2006/01/21 00:41:00  glen
- fix md5

Revision 1.211.2.1  2005/08/10 21:46:00  glen
- just testing DSO in 1.3.0. read README.DSO in sources
- note rc2 doesn't compile, while rc1 does.
- had to update shaper to 0.5.6 for 1.3.0

Revision 1.211  2005/08/10 20:46:43  glen
- no main package is built, moved %descriptions to -common package
- rel 7

Revision 1.210  2005/08/10 20:41:02  glen
- removed logrotate; xferlog is rotated by syslog daemons
- other minor fixes

Revision 1.209  2005/08/10 09:31:46  glen
- adapterized

Revision 1.208  2005/08/08 14:30:57  glen
- optimize, increase readability, unify triggers/post scriptlets

Revision 1.207  2005/08/08 14:22:43  glen
- optimize triggers to use only one sed invocation
- add missing Requires(triggerpostun) for sed 4.0

Revision 1.206  2005/08/08 13:55:38  hawk
- handle TLS options in triggers

Revision 1.205  2005/08/08 11:35:39  hawk
- fixed triggers (how they were supposed to work if they weren't included
  in subpackages at all?)
- fixed typos in triggers

Revision 1.204  2005/08/04 14:00:59  adamg
- fixes for CAN-2005-2390 (format string vulnerabilities)
- release 6

Revision 1.203  2005/05/18 11:54:13  qboosh
- moved updated R: pam to -common (no base package)

Revision 1.202  2005/05/12 14:37:56  baggins
- release 5
- req pam 0.79

Revision 1.201  2005/03/29 08:56:36  glen
- increase readability: use $MODULES var for --with-modules arg

Revision 1.200  2005/03/29 08:38:12  marcus
- added missing ":" in quota pgsql bcond

Revision 1.199  2005/03/17 20:04:46  glen
- updated %description
- minor cosmetics

Revision 1.198  2005/03/17 19:53:34  glen
- mod_shaper support by Justas Vilimas <justas.vilimas/at/delfi.lt>

Revision 1.197  2005/02/12 22:50:00  arekm
- rel ++

Revision 1.196  2005/02/09 06:25:03  blekot
- cosmetics (I've forgotten to write it before ci)

Revision 1.195  2005/02/09 06:21:02  blekot
- patch from (Marcin Sztolcman <msztolcman {at} post {dot} pl>)
- rel +1
- STBR test

Revision 1.194  2005/02/03 17:26:31  baggins
- release 2
- removed IPv6 patch (obsolete, v6 support now in mainline)
- removed vmail patch (no one seemed to care for a year)
- added sendfile64 patch (fix large file transfer using sendfile(2))

Revision 1.193  2004/12/14 20:14:03  saq
- applying more logic

Revision 1.192  2004/12/14 19:37:16  ankry
- logical error message

Revision 1.191  2004/12/14 19:26:26  mwinkler
- info error when build --with mysql and pgsql

Revision 1.190  2004/11/23 08:36:42  trojan
- fixed building with mysql

Revision 1.189  2004/10/29 14:08:25  blues
- better trigger

Revision 1.188  2004/10/29 08:17:38  paladine
- "FTP" unification

Revision 1.187  2004/10/25 12:14:04  blues
- even more docs

Revision 1.186  2004/10/25 12:07:51  blues
- more docs (human-readable form...)

Revision 1.185  2004/10/25 12:04:42  blues
- trigger to change configuration - remove obsolete option

Revision 1.184  2004/10/24 20:44:20  paladine
- spelling fixes, uppercases, etc.

Revision 1.183  2004/10/09 18:08:38  hawk
- works ok for me, rel 1, STBR

Revision 1.182  2004/09/23 11:04:43  kolodko
- added macros in /etc/logrotate.d

Revision 1.181  2004/09/14 09:19:27  qboosh
- strict internal deps

Revision 1.180  2004/09/12 07:28:36  misi3k
- updated to 1.2.10
- rel 0.1
